Loading...
Searching...
No Matches
dolfinx Namespace Reference

Top-level namespace. More...

## Namespaces

namespace | common
| Miscellaneous classes, functions and types.
namespace | MPI
| MPI support functionality.
namespace | fem
| Finite element method functionality.
namespace | mesh
| Mesh data structures and algorithms on meshes.
namespace | la
| Linear algebra interface.
namespace | geometry
| Geometry data structures and algorithms.
namespace | graph
| Graph data structures and algorithms.
namespace | io
| Support for file IO.
namespace | nls
| Nonlinear solvers.
namespace | refinement
| Mesh refinement algorithms.

## Classes

struct | __unsigned_projection
struct | __radix_sort
class | Table
| This class provides storage and pretty-printing for tables. More...

## Concepts

concept | scalar

## Functions

std::string | version ()
| Return DOLFINx version string.
std::string | ufcx_signature ()
| Return UFC signature string.
std::string | git_commit_hash ()
consteval bool | has_debug ()
consteval bool | has_petsc ()
| Return true if DOLFINx is compiled with PETSc.
consteval bool | has_slepc ()
| Return true if DOLFINx is compiled with SLEPc.
consteval bool | has_parmetis ()
| Return true if DOLFINx is compiled with ParMETIS.
consteval bool | has_kahip ()
| Return true if DOLFINx is compiled with KaHIP.
consteval bool | has_adios2 ()
| Return true if DOLFINX is compiled with ADIOS2.
consteval bool | has_ptscotch ()
| Return true if DOLFINX is compiled with PT-SCOTCH.
consteval bool | has_complex_ufcx_kernels ()
void | init_logging (int argc, char *argv[])
| Optional initialisation of the logging backend.
Table | timing_table ()
| Return a summary of timings and tasks in a Table.
void | list_timings (MPI_Comm comm, Table::Reduction reduction=Table::Reduction::max)
| List a summary of timings and tasks.
std::pair< int, std::chrono::duration< double, std::ratio< 1 > > > | timing (const std::string &task)
| Return timing (count, total wall time) for given task.
std::map< std::string, std::pair< int, std::chrono::duration< double, std::ratio< 1 > > > > | timings ()
| Logged elapsed times.

## Variables

constexpr __unsigned_projection | unsigned_projection {}
| Projection from signed to signed int.
constexpr __radix_sort | radix_sort {}
| Radix sort.

## Detailed Description

Top-level namespace.

## Function Documentation

## git_commit_hash()

std::string git_commit_hash | ( |  | ) |

Return git changeset hash (returns "unknown" if changeset is not known)

## has_complex_ufcx_kernels()

bool has_complex_ufcx_kernels | ( |  | ) |

consteval

Return true if DOLFINx supports UFCx kernels with arguments of type C99 _Complex. When DOLFINx was built with MSVC this returns false. This returning false does not preclude using DOLFINx with kernels accepting std::complex.

## has_debug()

bool has_debug | ( |  | ) |

consteval

Return true if DOLFINx is compiled in debugging mode, i.e., with assertions on

## init_logging()

void init_logging | ( | int | argc,
|  | char * | argv[] )

Optional initialisation of the logging backend.

The log verbosity can be controlled from the command line using SPDLOG_LEVEL=<level>, where <level> is info, warn, debug, etc.

The full spdlog API can be used in applications to control the log system. See https://github.com/gabime/spdlog for the spdlog documentation.

Parameters

  [in] | argc | Number of command line arguments.
  [in] | argv | Command line argument vector.

## list_timings()

void list_timings | ( | MPI_Comm | comm,
|  | Table::Reduction | reduction = Table::Reduction::max )

List a summary of timings and tasks.

MPI_AVG reduction is printed.

Parameters

  [in] | comm | MPI Communicator.
  [in] | reduction | MPI Reduction to apply (min, max or average).

## timing()

std::pair< int, std::chrono::duration< double, std::ratio< 1 > > > timing | ( | const std::string & | task | ) |

Return timing (count, total wall time) for given task.

Parameters

  [in] | task | Name of a task

Returns
  The (count, total wall time) for the task.

## timing_table()

dolfinx::Table timing_table | ( |  | ) |

Return a summary of timings and tasks in a Table.

Returns
  Table with timings.

## timings()

std::map< std::string, std::pair< int, std::chrono::duration< double, std::ratio< 1 > > > > timings | ( |  | ) |

Logged elapsed times.

Returns
  Elapsed [task id: (count, total wall time)].